CreateRegKeys			PROTO STDCALL
CloseRegKeys			PROTO STDCALL
BrowseProjectFile		PROTO STDCALL 	:DWORD, :DWORD
GetLastUsedProject		PROTO STDCALL
SetCurrentProject		PROTO STDCALL
SetLastProject			PROTO STDCALL
GetINIFromProjectName	PROTO STDCALL
DeleteProject			PROTO STDCALL :DWORD
CheckProjectName		PROTO STDCALL :DWORD
GetProjectValue			PROTO STDCALL :DWORD, :DWORD, :DWORD
GetProjectInt			PROTO STDCALL :DWORD, :DWORD
SetProjectInt			PROTO STDCALL :DWORD, :DWORD, :DWORD

InitPopupMenus			PROTO STDCALL :DWORD
DeletePopupMenus		PROTO STDCALL
ShowPopupMenu			PROTO STDCALL :DWORD, :DWORD, :DWORD, :DWORD
ProcessMenu				PROTO STDCALL :DWORD, :DWORD





.code
CheckProjectName	proc	lpProjectName:DWORD
	mov		edx, lpProjectName
@textloop:
		mov		al, [edx]
		.IF		al==0
			jmp	@success
		.ELSEIF	al>="a" && al<="z" 
			jmp	@next
		.ELSEIF	al>="A" && al<="Z"
			jmp	@next
		.ELSEIF	al>="0" && al<="9"		
			jmp	@next
		.ELSEIF	al=="." || al=="-" || al==" "
			jmp	@next
		.ENDIF
		jmp		@failed
@next:
	inc		edx
	jmp		@textloop
@success:
xor		eax, eax
inc		eax
ret
@failed:
xor		eax, eax
ret
CheckProjectName	endp


DeleteProject	proc	lpProjectName:DWORD
	invoke	RegDeleteValue, hProjectsKey, lpProjectName
ret
DeleteProject	endp

GetINIFromProjectName	proc
LOCAL	PN_SIZE:DWORD
	mov			PN_SIZE, 259	
	invoke		RegQueryValueEx, hProjectsKey, ADDR CurProject, NULL,\
					NULL, ADDR CurProjectINI, ADDR PN_SIZE
ret
GetINIFromProjectName	endp


SetLastProject	proc
	invoke	lstrlen, ADDR CurProject
	inc		eax
	invoke	RegSetValueEx, hMainRegKey, ADDR LastProjectKey, NULL,\
				REG_SZ, ADDR CurProject, eax
	
	invoke	SetProjectInt, ADDR SectionGeneral, ADDR KeyLastBuild, dwCurBuild
ret
SetLastProject	endp


SetCurrentProject	proc
LOCAL	TempItem:MENUITEMINFO
	mov		TempItem.cbSize, SIZEOF TempItem
	mov		TempItem.fMask, MIIM_TYPE 
	mov		TempItem.fType, MFT_STRING		
	mov		TempItem.dwTypeData, offset CurProject
	invoke	SetMenuItemInfo, hMainMenu, IDM_CURPROJECT, FALSE, ADDR TempItem
	invoke	GetProjectInt, ADDR SectionGeneral, ADDR KeyLastBuild
	.IF		eax==BUILD_DEBUG
		mov		dwCurBuild, eax
		mov		pCurBuild, offset SectionDebug
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_DEBUG, MF_BYCOMMAND or MF_CHECKED
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_RELEASE, MF_BYCOMMAND or MF_UNCHECKED
	.ELSE
		mov		dwCurBuild, BUILD_RELEASE
		mov		pCurBuild, offset SectionRelease
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_DEBUG, MF_BYCOMMAND or MF_UNCHECKED
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_RELEASE, MF_BYCOMMAND or MF_CHECKED
	.ENDIF
ret
SetCurrentProject	endp


GetLastUsedProject	proc	uses ebx 
LOCAL	ProjectName[41]:BYTE
LOCAL	PN_SIZE:DWORD
LOCAL	PF_SIZE:DWORD
	mov			PN_SIZE, 41
	invoke		RegQueryValueEx, hMainRegKey, ADDR LastProjectKey, NULL,\
					NULL, ADDR LastProject, ADDR PN_SIZE
	xor		ebx, ebx
	.WHILE	TRUE
		mov		PN_SIZE, 41
		mov	PF_SIZE, 260
		invoke	RegEnumValue, hProjectsKey, ebx, ADDR ProjectName, ADDR PN_SIZE,\
					NULL, NULL,ADDR CurProjectINI, ADDR PF_SIZE
		.IF		eax==ERROR_NO_MORE_ITEMS
			.BREAK
		.ENDIF
		invoke	lstrcmp, ADDR ProjectName, ADDR LastProject
		.IF		eax==0
			inc		eax
			ret
		.ENDIF
		inc	ebx
	.ENDW
xor		eax, eax
ret
GetLastUsedProject	endp



BrowseProjectFile proc	hWnd:DWORD, lpBuffer:DWORD
LOCAL 	OFN:OPENFILENAME
	mov		OFN.lStructSize, SIZEOF OPENFILENAME
	push	hWnd
	pop		OFN.hWndOwner
	push	hInstance
	pop		OFN.hInstance
	mov		OFN.lpstrFilter, offset IniFilter
	mov		OFN.lpstrCustomFilter, NULL
	mov		OFN.nFilterIndex, 0
	mov		eax, lpBuffer
	mov		byte ptr [eax],0
	mov		OFN.lpstrFile, eax
	mov		OFN.nMaxFile, 300
	mov		OFN.lpstrFileTitle, offset TitleText
	mov		OFN.lpstrInitialDir, NULL
	mov		OFN.lpstrTitle, NULL
	mov		OFN.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST
	mov		OFN.lpstrDefExt, NULL
	invoke	GetOpenFileName, ADDR OFN
	
ret
BrowseProjectFile endp

CreateRegKeys	proc

	invoke	RegOpenKeyEx, HKEY_CURRENT_USER, ADDR MainRegKey, \
			NULL,  KEY_READ	or KEY_WRITE		, ADDR hMainRegKey
	.IF		eax!=ERROR_SUCCESS
		invoke	RegCreateKeyEx, HKEY_CURRENT_USER, ADDR MainRegKey, \
				NULL, NULL, NULL,   KEY_READ	or KEY_WRITE	, NULL, ADDR hMainRegKey, ADDR KeyDisp
	.ENDIF
	.IF		eax!=ERROR_SUCCESS
		jmp crr_failed
	.ENDIF

	invoke	RegOpenKeyEx, hMainRegKey, ADDR ProjectsKey,\
			NULL,   KEY_READ	or KEY_WRITE, ADDR hProjectsKey
	.IF		eax!=ERROR_SUCCESS
		invoke	RegCreateKeyEx, hMainRegKey, ADDR ProjectsKey, \
				NULL, NULL, NULL,   KEY_READ	or KEY_WRITE, NULL, ADDR hProjectsKey, ADDR KeyDisp
	.ENDIF
	.IF		eax!=ERROR_SUCCESS
		jmp crr_failed
	.ENDIF
	
	jmp		crr_success
crr_failed:

	invoke	MessageBox, NULL, ADDR ERRreg, ADDR AppName, MB_OK or MB_ICONERROR
	invoke	ExitProcess, 1
crr_success:

ret
CreateRegKeys	endp


CloseRegKeys	proc
	invoke	RegCloseKey, hProjectsKey
	invoke	RegCloseKey, hMainRegKey
ret
CloseRegKeys	endp


		
GetProjectInt	proc	lpSection:DWORD, lpKey:DWORD
		invoke	GetPrivateProfileInt, lpSection, lpKey, -1,ADDR CurProjectINI
ret
GetProjectInt	endp
				
GetProjectValue	proc	lpSection:DWORD, lpKey:DWORD, lpBuffer:DWORD
		invoke	GetPrivateProfileString,lpSection, lpKey,\
					ADDR KeyDefault, lpBuffer, 299,\
					ADDR CurProjectINI 
		mov		ecx, lpBuffer
		.IF		(eax==4 && dword ptr [ecx]=="_@!_")
			xor		eax, eax
			ret
		.ENDIF
ret
GetProjectValue endp

SetProjectInt	proc	lpSection:DWORD, lpKey:DWORD, value:DWORD
LOCAL	Buffer[16]:BYTE
	invoke	wsprintf, ADDR Buffer, ADDR FormatNumber, value
	invoke	WritePrivateProfileString, lpSection, lpKey, ADDR Buffer, ADDR CurProjectINI
ret
SetProjectInt	endp

 

InitPopupMenus		proc	hWnd:DWORD

	;---------------------------------------------
	; Main popup menu
	;------------
	invoke		CreatePopupMenu
	mov			hMainMenu, eax
	; current project name menu item:
	invoke		InsertMenu, hMainMenu, 0, MF_BYPOSITION or MF_STRING or MF_DISABLED\
					, IDM_CURPROJECT, ADDR textNoCurProject
	;seperator 1
	invoke		InsertMenu, hMainMenu, 1, MF_BYPOSITION or MF_SEPARATOR	\
					, NULL, NULL
	; "Project manager" menu item:
	invoke		InsertMenu, hMainMenu, 2, MF_BYPOSITION	 or MF_STRING or MF_ENABLED\
					, IDM_PROJECTMANAGER, ADDR textProjectMng
					
					
	; "Edit project file" menu item:
	invoke		InsertMenu, hMainMenu, 3, MF_BYPOSITION	 or MF_STRING or MF_ENABLED\
					, IDM_EDITPROJECTFILE, ADDR textOpenINI

	;seperator 2
	invoke		InsertMenu, hMainMenu, 4, MF_BYPOSITION or MF_SEPARATOR	\
					, NULL, NULL
	; "About" menu item:
	invoke		InsertMenu, hMainMenu, 5, MF_BYPOSITION	 or MF_STRING or MF_ENABLED\
					, IDM_ABOUT, ADDR textAbout	

	; "Exit" menu item:
	invoke		InsertMenu, hMainMenu, 6, MF_BYPOSITION	 or MF_STRING or MF_ENABLED\
					, IDM_EXIT, ADDR textExit	
	
	;---------------------------------------------
	; Select build popup menu
	;------------
	
	invoke		CreatePopupMenu
	mov			hBuildMenu, eax

	; release build menu item:
	invoke		InsertMenu, hBuildMenu, 0,MF_BYPOSITION or MF_STRING or MF_ENABLED,\
					IDM_BUILD_RELEASE, ADDR textReleaseBuild
	; debug build menu item:
	invoke		InsertMenu, hBuildMenu, 1,MF_BYPOSITION or MF_STRING or MF_ENABLED,\
					IDM_BUILD_DEBUG, ADDR textDebugBuild
					
					
ret
InitPopupMenus		endp



DeletePopupMenus		proc		
	invoke		DestroyMenu, hMainMenu
ret
DeletePopupMenus		endp


ShowPopupMenu		proc		hWnd:DWORD,hMenu:DWORD, xPos:DWORD, yPos:DWORD
	;Show a popup menu at xPos, yPos. hWnd receives the WM_COMMAND message if
	;a menu item is clickede
	invoke		TrackPopupMenu, hMenu,TPM_LEFTALIGN	or TPM_LEFTBUTTON,\
				 xPos, yPos, NULL, hWnd, NULL
ret
ShowPopupMenu		endp

ProcessMenu	proc hWnd:DWORD, wID:DWORD
	mov		eax, wID
	.IF		eax==IDM_EXIT
		invoke	SendMessage, hWnd, WM_CLOSE, NULL, NULL
	.ELSEIF	eax==IDM_PROJECTMANAGER
		invoke	ShowProjectManager, hWnd
	.ELSEIF eax==IDM_BUILD_RELEASE
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_RELEASE, MF_BYCOMMAND or MF_CHECKED
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_DEBUG, MF_BYCOMMAND or MF_UNCHECKED
		mov		dwCurBuild, BUILD_RELEASE
		mov		pCurBuild, offset SectionRelease
	.ELSEIF eax==IDM_BUILD_DEBUG
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_RELEASE, MF_BYCOMMAND or MF_UNCHECKED
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_DEBUG, MF_BYCOMMAND or MF_CHECKED
		mov		dwCurBuild, BUILD_DEBUG
		mov		pCurBuild, offset SectionDebug
	.ELSEIF eax==IDM_EDITPROJECTFILE
		invoke	ShellExecute, hWnd, ADDR tOpOpen, ADDR CurProjectINI, NULL, NULL, SW_SHOW
		.IF		eax<=32
			MSGBOX "Error: could not open project file"
		.ENDIF
	.ELSEIF eax==IDM_ABOUT
		invoke	MessageBox, NULL, ADDR tAbout, ADDR AppName, MB_ICONINFORMATION
	.ENDIF
ret
ProcessMenu	endp









