;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; IDEBar v1.2 - Project manager.asm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Code for the project manager dialog and new project dialog
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;===============================================================================
;	Prototypes
;===============================================================================
ShowProjectManager		PROTO	STDCALL :DWORD
PMDlgProc				PROTO	STDCALL :DWORD, :DWORD, :DWORD, :DWORD
PNDlgProc				PROTO	STDCALL :DWORD, :DWORD, :DWORD, :DWORD

.code
;===============================================================================
;	Show project manager
;===============================================================================
ShowProjectManager	proc	hWnd:DWORD
	invoke	DialogBoxParam, hInstance, IDD_PROJECTMANAGER, hWnd, ADDR PMDlgProc, NULL
	invoke	SetCurrentProject
ret
ShowProjectManager	endp

;===============================================================================
;	Project manager dialog proc
;===============================================================================	
PMDlgProc	proc	uses ebx hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL	ProjectName[41]:BYTE
LOCAL	TempProject[41]:BYTE
LOCAL	ProjectFile[260]:BYTE
LOCAL	TempINI[260]:BYTE
LOCAL	PN_SIZE:DWORD
LOCAL	PF_SIZE:DWORD
	mov		eax, uMsg
	.IF		eax==WM_INITDIALOG
		invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_RESETCONTENT, 0, 0
		mov			PN_SIZE, 41
		invoke		RegQueryValueEx, hMainRegKey, ADDR LastProjectKey, NULL,\
						NULL, ADDR LastProject, ADDR PN_SIZE
		xor		ebx, ebx
		.WHILE	TRUE
			mov		PN_SIZE, 41
			;mov	PF_SIZE, 260
			invoke	RegEnumValue, hProjectsKey, ebx, ADDR ProjectName, ADDR PN_SIZE,\
						NULL, NULL,NULL,NULL ;ADDR ProjectFile, ADDR PF_SIZE
			.IF		eax==ERROR_NO_MORE_ITEMS
				.BREAK
			.ENDIF
			invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_ADDSTRING, NULL, ADDR ProjectName
			push	eax
			invoke	lstrcmp, ADDR ProjectName, ADDR LastProject
			.IF		eax==0
				pop		eax
				invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_SETCURSEL, eax, NULL
			.ELSE
				pop		eax
			.ENDIF
			inc	ebx
		.ENDW
	.ELSEIF	eax==WM_COMMAND
		mov		eax, wParam
		shr		eax, 16
		.IF		eax==BN_CLICKED
			mov		eax, wParam
			.IF		ax==IDC_SELECT
				invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_GETCURSEL, 0, 0
				.IF		eax!=LB_ERR
					invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS,\
						 LB_GETTEXT, eax, ADDR CurProject
					invoke	GetINIFromProjectName
					invoke	SetLastProject
				.ENDIF
				invoke	EndDialog, hWnd, NULL
			.ELSEIF	ax==IDC_REMOVE
				invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_GETCURSEL, 0, 0
				mov		ebx, eax
				.IF		eax==LB_ERR
					invoke	MessageBeep, NULL
				.ELSE
					invoke	MessageBox, NULL, ADDR qtRemoveProject, ADDR AppName,\
								 MB_ICONQUESTION + MB_YESNO
					.IF		eax==IDYES
						invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS,\
						 LB_GETTEXT, ebx, ADDR TempProject
						invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS,\
						 LB_DELETESTRING, ebx, 0
						invoke	DeleteProject, ADDR TempProject
					.ENDIF
				.ENDIF
			.ELSEIF	ax==IDC_ADD
				invoke	DialogBoxParam, hInstance, IDD_NEWPROJECT, hWnd, ADDR PNDlgProc, 0
			.ENDIF
		.ENDIF
	
	.ELSEIF		eax==WM_DESTROY
		invoke	EndDialog, hWnd, NULL
	.ELSEIF	eax==WM_CLOSE
		invoke	EndDialog, hWnd, NULL
	.ENDIF
xor eax,eax
ret
PMDlgProc	endp


PNDlgProc	proc	hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL	TempProject[41]:BYTE
LOCAL	TempINI[260]:BYTE
	mov		eax, uMsg
	.IF		eax==WM_INITDIALOG
		invoke	SendDlgItemMessage, hWnd, IDC_PROJECTNAME, EM_SETLIMITTEXT, 40, 0
	.ELSEIF	eax==WM_COMMAND
		mov		eax, wParam
		shr		eax, 16
		.IF		eax==BN_CLICKED
			mov		eax, wParam
			.IF		ax==IDCANCEL
				invoke	EndDialog, hWnd, NULL
			.ELSEIF	ax==IDOK
				invoke	GetDlgItemText, hWnd, IDC_PROJECTNAME, ADDR TempProject, 40
				invoke	CheckProjectName, ADDR TempProject
				.IF		eax==0
					invoke	MessageBox, NULL, ADDR ErrWrongName, ADDR AppName, MB_ICONERROR
				.ELSE
				; --- check if project name already exists
				invoke	RegQueryValueEx, hProjectsKey, ADDR TempProject, NULL, NULL, NULL, NULL
				.IF		eax==ERROR_SUCCESS
					MSGBOX "This project name already exists, please choose another one."
				ret
				.ENDIF
				invoke	BrowseProjectFile, hWnd, ADDR TempINI
				.IF		eax==TRUE
					invoke	lstrlen, ADDR TempINI
					inc		eax
					invoke	RegSetValueEx, hProjectsKey, ADDR TempProject, NULL,\
					REG_SZ, ADDR TempINI, eax
					invoke	GetParent, hWnd
					invoke	SendMessage, eax, WM_INITDIALOG, 0,0
					invoke	lstrcpy, ADDR CurProject, ADDR TempProject
					invoke	SetCurrentProject
					invoke	SetLastProject
				.ENDIF
		
					
					invoke	EndDialog, hWnd, 1
				.ENDIF
			.ENDIF
		.ENDIF
	.ELSEIF		eax==WM_DESTROY
		invoke	EndDialog, hWnd, NULL
	.ELSEIF	eax==WM_CLOSE
		invoke	EndDialog, hWnd, NULL
	.ENDIF
xor eax,eax
ret
PNDlgProc	endp

